'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactFlex = require('react-flex');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _dragHelper = require('drag-helper');

var _dragHelper2 = _interopRequireDefault(_dragHelper);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _join = require('./join');

var _join2 = _interopRequireDefault(_join);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CLASS_NAME = 'react-split-container__splitter';

var emptyFn = function emptyFn() {};

var ARROWS = {
  right: _react2.default.createElement(
    'svg',
    { fill: '#000000', height: '22', width: '22', viewBox: '0 0 24 24', xmlns: 'http://www.w3.org/2000/svg' },
    _react2.default.createElement('path', { d: 'M8.59 16.34l4.58-4.59-4.58-4.59L10 5.75l6 6-6 6z' }),
    _react2.default.createElement('path', { d: 'M0-.25h24v24H0z', fill: 'none' })
  ),
  left: _react2.default.createElement(
    'svg',
    { fill: '#000000', height: '22', width: '22', viewBox: '0 0 24 24', xmlns: 'http://www.w3.org/2000/svg' },
    _react2.default.createElement('path', { d: 'M15.41 16.09l-4.58-4.59 4.58-4.59L14 5.5l-6 6 6 6z' }),
    _react2.default.createElement('path', { d: 'M0-.5h24v24H0z', fill: 'none' })
  ),
  down: _react2.default.createElement(
    'svg',
    { fill: '#000000', height: '22', width: '22', viewBox: '0 0 24 24', xmlns: 'http://www.w3.org/2000/svg' },
    _react2.default.createElement('path', { d: 'M7.41 7.84L12 12.42l4.59-4.58L18 9.25l-6 6-6-6z' }),
    _react2.default.createElement('path', { d: 'M0-.75h24v24H0z', fill: 'none' })
  ),
  up: _react2.default.createElement(
    'svg',
    { fill: '#000000', height: '22', width: '22', viewBox: '0 0 24 24', xmlns: 'http://www.w3.org/2000/svg' },
    _react2.default.createElement('path', { d: 'M7.41 15.41L12 10.83l4.59 4.58L18 14l-6-6-6 6z' }),
    _react2.default.createElement('path', { d: 'M0 0h24v24H0z', fill: 'none' })
  )
};

var Splitter = function (_Component) {
  _inherits(Splitter, _Component);

  function Splitter() {
    _classCallCheck(this, Splitter);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Splitter).apply(this, arguments));
  }

  _createClass(Splitter, [{
    key: 'prepareChildren',
    value: function prepareChildren(props) {
      var result = [];
      var horizontal = props.orientation == 'horizontal';

      var className = CLASS_NAME + '-inner';
      var row = horizontal;
      var column = !row;

      var flexProps = {
        justifyContent: 'center',
        alignItems: 'center',
        wrap: false,
        row: row,
        column: column
      };

      var collapsedIndex = props.collapsedIndex;
      var locked = props.locked;


      if (locked) {
        return null;
      }

      var firstCollapsed = collapsedIndex == 0;
      var secondCollapsed = collapsedIndex == 1;

      var collapsible = props.collapsible || [];
      var firstCollapsible = collapsible[0] !== false;
      var secondCollapsible = collapsible[1] !== false;

      if (firstCollapsible && !firstCollapsed || secondCollapsed) {
        result.push(_react2.default.createElement(
          _reactFlex.Flex,
          _extends({}, flexProps, {
            key: 'first',
            className: (0, _join2.default)(className, className + '--first', className + '--orientation-' + props.orientation),
            onClick: this.toggleCollapse.bind(this, -1)
          }),
          horizontal ? ARROWS.up : ARROWS.left
        ));
      }

      if (secondCollapsible && !secondCollapsed || firstCollapsed) {
        result.push(_react2.default.createElement(
          _reactFlex.Flex,
          _extends({}, flexProps, {
            key: 'second',
            className: (0, _join2.default)(className, className + '--second', className + '--orientation-' + props.orientation),
            onClick: this.toggleCollapse.bind(this, 1)
          }),
          horizontal ? ARROWS.down : ARROWS.right
        ));
      }

      return result;
    }
  }, {
    key: 'prepareProps',
    value: function prepareProps(thisProps) {
      var props = (0, _objectAssign2.default)({}, this.props);

      props.className = this.prepareClassName(props);
      props.children = this.prepareChildren(props);

      return props;
    }
  }, {
    key: 'prepareClassName',
    value: function prepareClassName(props) {
      var collapsedIndex = props.collapsedIndex;
      var collapsing = props.collapsing;
      var expanding = props.expanding;
      var locked = props.locked;
      var draggable = props.draggable;
      var constrained = props.constrained;


      return (0, _join2.default)(props.className, CLASS_NAME, CLASS_NAME + '--orientation-' + props.orientation, locked && CLASS_NAME + '--locked', draggable && CLASS_NAME + '--draggable', constrained && CLASS_NAME + '--constrained', collapsedIndex != undefined && (0, _join2.default)(CLASS_NAME + '--collapsed', CLASS_NAME + '--collapsed-' + (collapsedIndex == 0 ? 'start' : 'end')));
    }
  }, {
    key: 'render',
    value: function render() {

      var props = this.prepareProps(this.props);

      var horizontal = props.orientation == 'horizontal';

      var row = horizontal;
      var column = !row;

      return _react2.default.createElement(_reactFlex.Flex, _extends({
        wrap: false,
        row: row,
        column: column,
        justifyContent: 'center',
        alignItems: 'center'
      }, props, {
        draggable: null,
        onDoubleClick: this.handleDoubleClick,
        onMouseDown: this.handleMouseDown
      }));
    }
  }, {
    key: 'handleDoubleClick',
    value: function handleDoubleClick(event) {
      this.props.onDoubleClick(event);

      var collapsedIndex = this.props.collapsedIndex;


      if (collapsedIndex == null) {
        return;
      }

      this.toggleCollapse(collapsedIndex == 0 ? 1 : -1);
    }
  }, {
    key: 'handleMouseDown',
    value: function handleMouseDown(event) {

      event.preventDefault();

      this.props.onMouseDown(event);

      if (this.props.locked || !this.props.draggable || this.props.collapsedIndex != null) {
        return;
      }

      var node = (0, _reactDom.findDOMNode)(this);
      var parent = node.parentNode;
      var zeroPositionName = this.props.orientation == 'vertical' ? 'top' : 'left';

      (0, _dragHelper2.default)(event, {
        scope: this,
        region: node,
        constrainTo: parent,
        onDragStart: function onDragStart(event, config) {
          config.diff[zeroPositionName] = 0;
          this.props.onDragStart(config.diff, event);
        },

        onDrag: function onDrag(event, config) {
          config.diff[zeroPositionName] = 0;
          this.props.onDrag(config.diff, event);
        },

        onDrop: function onDrop(event, config) {
          config.diff[zeroPositionName] = 0;
          this.props.onDrop(config.diff, event);
        }
      });
    }
  }, {
    key: 'toggleCollapse',
    value: function toggleCollapse(direction, event) {

      // event.stopPropagation()

      if (this.props.locked) {
        return;
      }

      var _props = this.props;
      var collapsedIndex = _props.collapsedIndex;
      var onExpand = _props.onExpand;
      var onCollapse = _props.onCollapse;


      var index = collapsedIndex != undefined ?
      //there is a collapsed item
      //so we are expanding
      collapsedIndex :

      //otherwise, we are collapsing
      direction == 1 ? 1 : 0;

      var fn = collapsedIndex === index ? onExpand : onCollapse;

      fn(index, event);
    }
  }]);

  return Splitter;
}(_reactClass2.default);

exports.default = Splitter;


Splitter.propTypes = {
  size: _react.PropTypes.number,
  orientation: _react.PropTypes.string,
  locked: _react.PropTypes.bool,

  collapsedIndex: _react.PropTypes.oneOf([undefined, 0, 1])
};

Splitter.defaultProps = {
  isSplitter: true,

  onDragStart: emptyFn,
  onDrag: emptyFn,
  onDrop: emptyFn,

  onCollapse: emptyFn,
  onExpand: emptyFn,

  onDoubleClick: emptyFn,
  onMouseDown: emptyFn,
  beforeMin: null,
  afterMin: null
};