'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Side = exports.Splitter = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _raf = require('raf');

var _raf2 = _interopRequireDefault(_raf);

var _reactFlex = require('react-flex');

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _reactStyleNormalizer = require('react-style-normalizer');

var _reactStyleNormalizer2 = _interopRequireDefault(_reactStyleNormalizer);

var _Splitter = require('./Splitter');

var _Splitter2 = _interopRequireDefault(_Splitter);

var _join = require('./join');

var _join2 = _interopRequireDefault(_join);

var _bemFactory = require('./bemFactory');

var _bemFactory2 = _interopRequireDefault(_bemFactory);

var _isNumber = require('./isNumber');

var _isNumber2 = _interopRequireDefault(_isNumber);

var _calc = require('./calc');

var _calc2 = _interopRequireDefault(_calc);

var _getTransitionEnd = require('./getTransitionEnd');

var _getTransitionEnd2 = _interopRequireDefault(_getTransitionEnd);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PERCENTAGE_RE = /%/;
var CLASS_NAME = 'react-split-container';

var minMax = function minMax(min, max) {
  return {
    min: Math.min(min, max),
    max: Math.max(min, max)
  };
};

var clamp = function clamp(n, min, max) {
  return Math.max(Math.min(n, max), min);
};

var bem = (0, _bemFactory2.default)(CLASS_NAME);
var m = function m(name) {
  return bem(null, name);
};

var prefixFlexGrow = function prefixFlexGrow(value) {
  return {
    WebkitBoxFlex: value,
    WebkitFlexGrow: value,
    MozFlexGrow: value,
    MsFlexPositive: value,
    flexGrow: value
  };
};

var prefixFlex = function prefixFlex(value) {
  return {
    WebkitBoxFlex: value,
    WebkitFlex: value,
    MozFlex: value,
    MsFlex: value,
    flex: value
  };
};

var isPercentage = function isPercentage(n) {
  if ((0, _isNumber2.default)(n)) {
    return false;
  }

  return typeof n == 'string' && (0, _isNumber2.default)(n.replace(PERCENTAGE_RE, ''));
};

var getSizeName = function getSizeName(props) {
  return props.orientation == 'horizontal' ? 'height' : 'width';
};

var getOtherSizeName = function getOtherSizeName(props) {
  return props.orientation == 'horizontal' ? 'width' : 'height';
};

var getMaxSizeName = function getMaxSizeName(props) {
  return props.orientation == 'horizontal' ? 'maxHeight' : 'maxWidth';
};

var getMinSizeName = function getMinSizeName(props) {
  return props.orientation == 'horizontal' ? 'minHeight' : 'minWidth';
};

var getPositionNames = function getPositionNames(props) {
  var H = props.orientation == 'horizontal';
  return H ? ['top', 'bottom'] : ['left', 'right'];
};

var toUpperFirst = function toUpperFirst(str) {
  return typeof str === 'string' ? str[0].toUpperCase() + str.substring(1) : '';
};

var getOffsetSizeName = function getOffsetSizeName(props) {
  var sizeName = getSizeName(props);

  return 'client' + toUpperFirst(sizeName);
};

var emptyFn = function emptyFn() {};

var getOffsetSize = function getOffsetSize(node) {

  if (node.getBoundingClientRect) {
    var rect = node.getBoundingClientRect();

    return {
      width: rect.width,
      height: rect.height
    };
  }

  return {
    width: node.offsetWidth,
    height: node.offsetHeight
  };
};

var inDevMode = /param/.test(function (param) {});
/**
 * node is the flex wrapper, node.firstChild is the Side, and node.firstChild.firstChild is the actual node
 * we are measuring the auto size for
 */
var getAutoSize = function getAutoSize(node) {
  var targetNode = node.firstChild.firstChild;

  var size = getOffsetSize(targetNode);
  var borderPadding = getBorderPaddingSize(node.firstChild);

  return {
    width: size.width + borderPadding.left + borderPadding.right,
    height: size.height + borderPadding.top + borderPadding.bottom
  };
};

var toNumber = function toNumber(n) {
  return parseInt(n, 10);
};

var getBorderPaddingSize = function getBorderPaddingSize(node) {
  var computedStyle = global.getComputedStyle(node);

  return {
    left: toNumber(computedStyle.borderLeftWidth) + toNumber(computedStyle.paddingLeft),
    right: toNumber(computedStyle.borderRightWidth) + toNumber(computedStyle.paddingRight),
    top: toNumber(computedStyle.borderTopWidth) + toNumber(computedStyle.paddingTop),
    bottom: toNumber(computedStyle.borderBottomWidth) + toNumber(computedStyle.paddingBottom)
  };
};

var SplitSide = function (_Component) {
  _inherits(SplitSide, _Component);

  function SplitSide() {
    _classCallCheck(this, SplitSide);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(SplitSide).apply(this, arguments));
  }

  _createClass(SplitSide, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(_reactFlex.Item, this.props);
    }
  }]);

  return SplitSide;
}(_reactClass2.default);

SplitSide.propTypes = {
  children: function children(props, propsName) {
    if (props.index == props.splitAtIndex && props.splitAtValue == 'auto' && _react2.default.Children.toArray(props.children).length > 1) {
      return new Error('The SplitContainer side at index ' + props.splitAtIndex + ' has "auto" splitValue but has multiple children. It should only have 1 child!');
    }
  }
};

var Side = function (_Component2) {
  _inherits(Side, _Component2);

  function Side() {
    _classCallCheck(this, Side);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Side).apply(this, arguments));
  }

  _createClass(Side, [{
    key: 'render',
    value: function render() {
      return null;
    }
  }]);

  return Side;
}(_reactClass2.default);

Side.defaultProps = {
  isSplitContainerSide: true
};

exports.Splitter = _Splitter2.default;
exports.Side = Side;


var TRANSITION_DURATION = '0.4s';

var SplitContainer = function (_Component3) {
  _inherits(SplitContainer, _Component3);

  function SplitContainer(props) {
    _classCallCheck(this, SplitContainer);

    var _this3 = _possibleConstructorReturn(this, Object.getPrototypeOf(SplitContainer).call(this, props));

    var collapsedIndex = props.defaultCollapsedIndex;

    if (collapsedIndex != 0 && collapsedIndex != 1) {
      collapsedIndex = null;
    }

    _this3.state = {
      dragging: false,
      splitAt: props.defaultSplitAt,
      collapsedIndex: collapsedIndex
    };
    return _this3;
  }

  _createClass(SplitContainer, [{
    key: 'onTransitionEnd',
    value: function onTransitionEnd(event) {
      event && event.target && event.target.removeEventListener((0, _getTransitionEnd2.default)(), this.onTransitionEnd, false);

      this.setState({
        collapsing: false,
        expanding: false,

        collapsingIndex: null,
        expandingIndex: null,
        constrainingIndex: null,

        styles: null,

        expandStyle: null,
        collapseStyle: null,

        splitterStyle: null
      });
    }
  }, {
    key: 'hasTransition',
    value: function hasTransition(props) {
      return !!(props.transition || props.transitionDuration);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {

      var props = this.p;

      var collapsedIndex = props.collapsedIndex;
      var nextCollapsedIndex = this.prepareCollapsedIndex(nextProps);

      this.doTransition(nextProps, collapsedIndex, nextCollapsedIndex);
    }
  }, {
    key: 'doTransition',
    value: function doTransition(props, oldCollapsed, newCollapsed) {
      var collapsing = oldCollapsed == null && (newCollapsed == 0 || newCollapsed == 1);
      var expanding = (oldCollapsed == 0 || oldCollapsed == 1) && newCollapsed == null;

      if (collapsing) {
        this.transitionCollapse(props, newCollapsed);
      } else if (expanding) {
        this.transitionExpand(props, oldCollapsed);
      }
    }
  }, {
    key: 'getNodes',
    value: function getNodes(nodes) {
      if (nodes) {
        return nodes.map(_reactDom.findDOMNode);
      }

      return [(0, _reactDom.findDOMNode)(this.first), (0, _reactDom.findDOMNode)(this.second), (0, _reactDom.findDOMNode)(this.splitter)];
    }
  }, {
    key: 'transitionExpand',
    value: function transitionExpand(props, expandIndex) {
      var _styles$constrainingI,
          _styles$expandIndex,
          _splitterStyle,
          _this4 = this;

      var nodes = this.getNodes();

      var transitionDuration = (0, _reactStyleNormalizer2.default)({ transitionDuration: props.transitionDuration || TRANSITION_DURATION });

      var constrainingIndex = 1 - expandIndex;

      var sizeName = getSizeName(props);
      var otherSizeName = getOtherSizeName(props);

      var sideName = props.orientation == 'horizontal' ? constrainingIndex == 1 ? 'top' : 'bottom' : constrainingIndex == 1 ? 'left' : 'right';

      var otherSideName = props.orientation == 'horizontal' ? constrainingIndex == 1 ? 'left' : 'right' : constrainingIndex == 1 ? 'top' : 'bottom';

      var marginName = 'margin' + toUpperFirst(sideName);

      var splitAtIndex = props.splitAtIndex;
      var asPercentage = props.asPercentage;
      var splitAtValue = props.splitAtValue;


      var sizes = nodes.map(getOffsetSize);

      if (splitAtValue == 'auto') {
        sizes[splitAtIndex] = getAutoSize(nodes[splitAtIndex]);
      }

      var styles = [];

      var splitterSize = sizes[2][sizeName];

      var totalSize = getOffsetSize(nodes[0])[sizeName] + getOffsetSize(nodes[1])[sizeName];

      if (splitAtValue == 'auto') {
        splitAtValue = sizes[splitAtIndex][sizeName];
      }

      var expandSize = splitAtValue;

      if (asPercentage) {
        expandSize = splitAtValue * totalSize / 100;
      }

      if (expandIndex == 1) {
        expandSize = totalSize - expandSize;
      }

      if (splitAtIndex == 1) {
        expandSize = totalSize - expandSize;
      }

      styles[constrainingIndex] = (_styles$constrainingI = {}, _defineProperty(_styles$constrainingI, marginName, sizes[2][sizeName]), _defineProperty(_styles$constrainingI, otherSizeName, sizes[2][otherSizeName]), _styles$constrainingI);

      styles[expandIndex] = (_styles$expandIndex = {
        position: 'absolute',
        zIndex: 1000
      }, _defineProperty(_styles$expandIndex, otherSizeName, sizes[2][otherSizeName]), _defineProperty(_styles$expandIndex, sizeName, expandSize), _defineProperty(_styles$expandIndex, sideName, -expandSize), _defineProperty(_styles$expandIndex, otherSideName, 0), _styles$expandIndex);

      var splitterStyle = (_splitterStyle = {
        position: 'absolute',
        zIndex: 1000
      }, _defineProperty(_splitterStyle, sideName, 0), _defineProperty(_splitterStyle, otherSideName, 0), _splitterStyle);

      this.setState({
        expandingIndex: expandIndex,
        styles: styles,
        splitterStyle: splitterStyle
      }, function () {

        (0, _raf2.default)(function () {
          if (!expandSize) {
            if (props.splitAtValue == 'auto') {
              inDevMode && console && console.warn && console.warn('You are using \'splitAt="auto"\' but your content in side ' + constrainingIndex + ' is probably \'display:"block"\'.\n              Use \'display: "inline-block"\' for transitions on expand/collapse to work properly.');
            }

            return _this4.onTransitionEnd();
          }

          var expandNode = nodes[expandIndex];

          expandNode.addEventListener((0, _getTransitionEnd2.default)(), _this4.onTransitionEnd, false);

          (0, _raf2.default)(function () {
            var _assign;

            styles[expandIndex] = (0, _objectAssign2.default)({}, styles[expandIndex], (_assign = {}, _defineProperty(_assign, sizeName, expandSize), _defineProperty(_assign, sideName, 0), _assign), transitionDuration);

            _this4.setState({

              splitterStyle: (0, _objectAssign2.default)({}, splitterStyle, _defineProperty({}, sideName, expandSize), transitionDuration),

              styles: styles
            });
          });
        });
      });
    }
  }, {
    key: 'transitionCollapse',
    value: function transitionCollapse(props, nextCollapsedIndex) {
      var _styles$expandIndex2,
          _styles$collapsingInd,
          _splitterStyle2,
          _this5 = this;

      var nodes = this.getNodes();

      var expandIndex = 1 - nextCollapsedIndex;
      var collapsingIndex = nextCollapsedIndex;

      var sizeName = getSizeName(props);
      var otherSizeName = getOtherSizeName(props);

      var sideName = props.orientation == 'horizontal' ? nextCollapsedIndex == 1 ? 'bottom' : 'top' : nextCollapsedIndex == 1 ? 'right' : 'left';
      var otherSideName = props.orientation == 'horizontal' ? nextCollapsedIndex == 1 ? 'right' : 'left' : nextCollapsedIndex == 1 ? 'bottom' : 'top';

      var marginName = 'margin' + toUpperFirst(sideName);

      var transitionDuration = (0, _reactStyleNormalizer2.default)({
        transitionDuration: props.transitionDuration || TRANSITION_DURATION,
        transitionProperty: sideName
      });

      var sizes = nodes.map(getOffsetSize);

      var styles = [];

      styles[expandIndex] = (_styles$expandIndex2 = {}, _defineProperty(_styles$expandIndex2, marginName, sizes[2][sizeName]), _defineProperty(_styles$expandIndex2, otherSizeName, sizes[expandIndex][otherSizeName]), _styles$expandIndex2);

      styles[collapsingIndex] = (_styles$collapsingInd = {
        position: 'absolute',
        zIndex: 1000
      }, _defineProperty(_styles$collapsingInd, otherSizeName, sizes[collapsingIndex][otherSizeName]), _defineProperty(_styles$collapsingInd, sizeName, sizes[collapsingIndex][sizeName]), _defineProperty(_styles$collapsingInd, sideName, 0), _defineProperty(_styles$collapsingInd, otherSideName, 0), _styles$collapsingInd);

      var splitterStyle = (_splitterStyle2 = {
        position: 'absolute',
        zIndex: 1000,

        width: sizes[2].width,
        height: sizes[2].height

      }, _defineProperty(_splitterStyle2, sideName, sizes[collapsingIndex][sizeName]), _defineProperty(_splitterStyle2, otherSideName, 0), _splitterStyle2);

      this.setState({
        collapsing: true,

        collapsingIndex: collapsingIndex,

        sizes: sizes,
        styles: styles,

        splitterStyle: splitterStyle

      }, function () {

        (0, _raf2.default)(function () {
          setTimeout(function () {
            // debugger
          });
          var collapseNode = nodes[collapsingIndex];

          collapseNode.addEventListener((0, _getTransitionEnd2.default)(), _this5.onTransitionEnd, false);

          (0, _raf2.default)(function () {
            styles[collapsingIndex] = (0, _objectAssign2.default)({}, styles[collapsingIndex], _defineProperty({}, sideName, -sizes[collapsingIndex][sizeName]), transitionDuration);

            _this5.setState({
              splitterStyle: (0, _objectAssign2.default)({}, splitterStyle, _defineProperty({}, sideName, 0), transitionDuration),
              styles: styles
            });
          });
        });
      });
    }
  }, {
    key: 'prepareChildren',
    value: function prepareChildren(props) {
      var splitterProps = void 0;
      var firstProps = void 0;
      var secondProps = void 0;

      var children = [];

      _react2.default.Children.toArray(props.children).forEach(function (child, index) {
        if (child && child.props) {

          if (child.props.isSplitter) {
            splitterProps = child.props;
            return;
          }

          if (child.props.isSplitContainerSide) {
            if (index == 1) {
              secondProps = child.props;
            }
            if (index == 0) {
              firstProps = child.props;
            }

            children.push(child.props.children);

            return;
          }
        }

        children.push(child);
      });

      return {
        children: children,
        firstProps: firstProps,
        secondProps: secondProps,
        splitterProps: splitterProps
      };
    }
  }, {
    key: 'prepareCollapsedIndex',
    value: function prepareCollapsedIndex(props) {
      var state = arguments.length <= 1 || arguments[1] === undefined ? this.state : arguments[1];

      var collapsedIndex = props.collapsedIndex === undefined ? state.collapsedIndex : props.collapsedIndex;

      if (collapsedIndex !== 0 && collapsedIndex !== 1) {
        collapsedIndex = undefined;
      }

      return collapsedIndex;
    }
  }, {
    key: 'prepareClassNames',
    value: function prepareClassNames(props) {
      var children = props.children;
      var collapsedIndex = props.collapsedIndex;


      var firstClassName = children[0] && children[0].props && children[0].props.className;
      var secondClassName = children[1] && children[1].props && children[1].props.className;

      var expandingIndex = this.state.expandingIndex;
      var constrainingIndex = this.state.constrainingIndex;

      return [(0, _join2.default)(firstClassName, CLASS_NAME + '__side', CLASS_NAME + '__side--first', collapsedIndex == 0 ? this.state.collapsing ? CLASS_NAME + '__side--collapsing' : CLASS_NAME + '__side--collapsed' : '', expandingIndex == 0 && CLASS_NAME + '__side--expanding', constrainingIndex == 0 && CLASS_NAME + '__side--constraining', CLASS_NAME + '__side--orientation-' + props.orientation), (0, _join2.default)(secondClassName, CLASS_NAME + '__side', CLASS_NAME + '__side--second', collapsedIndex == 1 ? this.state.collapsing ? CLASS_NAME + '__side--collapsing' : CLASS_NAME + '__side--collapsed' : '', expandingIndex == 1 && CLASS_NAME + '__side--expanding', constrainingIndex == 1 && CLASS_NAME + '__side--constraining', CLASS_NAME + '__side--orientation-' + props.orientation)];
    }
  }, {
    key: 'prepareSplitAt',
    value: function prepareSplitAt(props) {
      var result = props.splitAt == null ? this.state.splitAt : props.splitAt;

      if (result == null) {
        return 'auto';
      }

      return result;
    }
  }, {
    key: 'prepareProps',
    value: function prepareProps(thisProps) {
      var props = this.p = (0, _objectAssign2.default)({}, thisProps);

      var _prepareChildren = this.prepareChildren(props);

      var children = _prepareChildren.children;
      var splitterProps = _prepareChildren.splitterProps;
      var firstProps = _prepareChildren.firstProps;
      var secondProps = _prepareChildren.secondProps;


      props.collapsedIndex = this.prepareCollapsedIndex(props);

      if (props.collapsedIndex !== 0 && props.collapsedIndex !== 1) {
        delete props.collapsedIndex;
      } else {
        props.notCollapsedIndex = 1 - props.collapsedIndex;
      }

      if (firstProps) {
        props.firstProps = firstProps;
      }

      if (secondProps) {
        props.secondProps = secondProps;
      }

      props.children = children;
      props.splitterProps = splitterProps;

      props.horizontal = props.orientation == 'horizontal';
      props.vertical = !props.orientation;

      props.splitAt = this.prepareSplitAt(props);
      props.className = this.prepareClassName(props);

      props.sizeName = getSizeName(props);
      props.otherSizeName = getOtherSizeName(props);
      props.minSizeName = getMinSizeName(props);
      props.maxSizeName = getMaxSizeName(props);

      props.asPercentage = isPercentage(props.splitAt);

      var splitAt = props.splitAt;


      var splitAtIndex = 0;
      var splitAtValue = void 0;

      if (splitAt == 'auto') {
        splitAtValue = 'auto';
      } else if (splitAt == '-auto') {
        splitAtValue = 'auto';
        splitAtIndex = 1;
      } else {
        splitAtValue = parseFloat(splitAt, 10);

        if (splitAtValue < 0) {
          if (props.asPercentage) {
            splitAtValue = 100 - (100 + splitAtValue);
          } else {
            splitAtValue *= -1;
          }

          splitAtIndex = 1;
        }
      }

      props.splitAtIndex = splitAtIndex;
      props.splitAtValue = splitAtValue;

      var fixedIndex = props.fixedIndex;


      if (fixedIndex != 0 && fixedIndex != 1) {
        fixedIndex = -1;
      }

      var flexIndex = 1 - fixedIndex;

      props.fixedIndex = fixedIndex;
      props.flexIndex = flexIndex;

      props.styles = this.prepareStyles(props);
      props.classNames = this.prepareClassNames(props);
      props.splitterStyle = this.prepareSplitterStyle(props);

      return props;
    }
  }, {
    key: 'prepareSplitterStyle',
    value: function prepareSplitterStyle(props) {
      var style = this.state.splitterStyle;

      return style;
    }
  }, {
    key: 'prepareStyles',
    value: function prepareStyles(props) {
      var state = this.state;

      var styles = [{}, {}
      //TODO - use those if you don't have all flex classes from 1 to 100
      // prefixFlexGrow('none'),
      // prefixFlexGrow('none')
      ];

      var sizeProps = props.sizeProps = [{
        flex: 'none'
      }, {
        flex: 'none'
      }];

      var collapsedIndex = props.collapsedIndex;
      var notCollapsedIndex = props.notCollapsedIndex;
      var splitAtIndex = props.splitAtIndex;
      var splitAtValue = props.splitAtValue;
      var flexIndex = props.flexIndex;
      var fixedIndex = props.fixedIndex;


      var otherIndex = 1 - splitAtIndex;

      var splitAtStyle = styles[splitAtIndex];
      var otherStyle = styles[otherIndex];

      var hasCollapsed = collapsedIndex != undefined;

      if (props.asPercentage) {

        // const percentage = splitAtIndex == 1?
        // if (splitAtIndex )
        sizeProps[splitAtIndex].flex = splitAtValue;
        sizeProps[otherIndex].flex = 100 - splitAtValue;
        //TODO - use those instead of the above when you don't have all classes from 1 to 100
        // assign(styles[splitAtIndex], prefixFlexGrow(splitAtValue))
        // assign(styles[otherIndex], prefixFlexGrow(100 - splitAtValue))
      } else {

          sizeProps[splitAtIndex].flex = 'none';
          sizeProps[otherIndex].flex = 1;

          styles[splitAtIndex][props.sizeName] = splitAtValue;
        }

      if (hasCollapsed) {
        styles[collapsedIndex] = _defineProperty({}, props.sizeName, 0);

        sizeProps[collapsedIndex].flex = 'none';
        sizeProps[notCollapsedIndex].flex = 1;
      }

      if (this.state.expandingIndex != null) {
        sizeProps[1 - this.state.expandingIndex].flex = 1;
      }

      var stateStyles = this.state.styles;

      if (stateStyles) {
        if (stateStyles[0]) {
          styles[0] = stateStyles[0];
        }

        if (stateStyles[1]) {
          styles[1] = stateStyles[1];
        }
      }

      (0, _objectAssign2.default)(styles[0], { overflow: 'hidden' });
      (0, _objectAssign2.default)(styles[1], { overflow: 'hidden' });

      sizeProps[0].style = styles[0];
      sizeProps[1].style = styles[1];

      return styles;
    }
  }, {
    key: 'prepareClassName',
    value: function prepareClassName(props) {
      return (0, _join2.default)(CLASS_NAME, m(props.orientation), m('orientation-' + props.orientation), props.theme && m('theme-' + props.theme), props.collapsing && m('collapsing'), props.locked && m('locked'), this.state.dragging && m('resizing'), this.state.constrained && m('constrained'));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      var props = this.p = this.prepareProps(this.props);

      var row = props.vertical;
      var column = props.horizontal;

      var firstProps = props.firstProps;
      var secondProps = props.secondProps;
      var splitterProps = props.splitterProps;
      var collapsedIndex = props.collapsedIndex;
      var notCollapsedIndex = props.notCollapsedIndex;


      var sizeProps = props.sizeProps;

      var newProps = [{
        flexShrink: 0,
        flexBasis: 0,
        className: props.classNames[0],
        children: this.renderFirst()
      }, {
        flexShrink: 0,
        flexBasis: 0,
        className: props.classNames[1],
        children: this.renderSecond()
      }];

      if (props.splitAtValue == 'auto' && props.splitAtIndex === collapsedIndex && this.state.collapsingIndex == null) {
        //when we have auto size for a region, in case it is collapsed
        //we need the Item to have flex none to allow the content be sized as is
        //and not wrap to another size
        newProps[props.splitAtIndex].flex = 'none';
      }

      var splitterStyle = (0, _objectAssign2.default)({}, (splitterProps || {}).style, props.splitterStyle);

      return _react2.default.createElement(
        _reactFlex.Flex,
        _extends({}, this.props, {
          draggable: null,
          row: row,
          column: column,
          wrap: false,
          alignItems: 'stretch',
          className: props.className
        }),
        _react2.default.createElement(
          _reactFlex.Flex,
          _extends({}, sizeProps[0], { alignSelf: 'stretch', alignItems: 'stretch', ref: function ref(c) {
              return _this6.first = c;
            } }),
          _react2.default.createElement(SplitSide, _extends({}, props.firstProps, newProps[0], {
            index: 0,
            splitAtValue: props.splitAtValue,
            splitAtIndex: props.splitAtIndex
          }))
        ),
        _react2.default.createElement(_Splitter2.default, _extends({}, splitterProps, {

          style: splitterStyle,
          ref: function ref(s) {
            return _this6.splitter = s;
          },

          onDragStart: this.handleSplitterDragStart,
          onDrag: this.handleSplitterDrag,
          onDrop: this.handleSplitterDrop,

          onCollapse: this.handleCollapse,
          onExpand: this.handleExpand,

          orientation: props.orientation,

          locked: props.locked,
          draggable: props.draggable,

          constrained: !props.resizeProxy && this.state.constrained,

          collapsedIndex: props.collapsedIndex,

          collapsible: props.collapsible
        })),
        _react2.default.createElement(
          _reactFlex.Flex,
          _extends({}, sizeProps[1], { alignSelf: 'stretch', alignItems: 'stretch', ref: function ref(c) {
              return _this6.second = c;
            } }),
          _react2.default.createElement(SplitSide, _extends({}, props.secondProps, newProps[1], {
            index: 1,
            splitAtValue: props.splitAtValue,
            splitAtIndex: props.splitAtIndex
          }))
        ),
        this.props.resizeProxy && this.renderResizeProxy(),
        this.renderCover()
      );
    }
  }, {
    key: 'renderCover',
    value: function renderCover() {

      if (this.props.renderCover) {
        return this.props.renderCover();
      }

      if (!this.props.cover) {
        return null;
      }

      var className = (0, _join2.default)(CLASS_NAME + '__cover', this.state.dragging && CLASS_NAME + '__cover--resizing');

      return _react2.default.createElement('div', {
        className: className,
        style: {
          display: this.state.dragging ? 'block' : 'none',
          position: 'absolute',
          zIndex: 1000,
          width: '100%',
          height: '100%',
          left: 0,
          top: 0
        }
      });
    }
  }, {
    key: 'renderResizeProxy',
    value: function renderResizeProxy() {
      var _style;

      var props = this.p;
      var positionNames = getPositionNames(props);

      var style = (_style = {
        display: this.state.dragging ? 'block' : 'none'
      }, _defineProperty(_style, props.otherSizeName, '100%'), _defineProperty(_style, props.sizeName, this.splitterSize), _defineProperty(_style, 'position', 'absolute'), _defineProperty(_style, 'zIndex', 1000), _defineProperty(_style, positionNames[0], this.state.dragPosition), _defineProperty(_style, props.orientation == 'horizontal' ? 'left' : 'top', 0), _style);

      var className = (0, _join2.default)(CLASS_NAME + '__resize-proxy', this.state.constrained && CLASS_NAME + '__resize-proxy--constrained');

      return _react2.default.createElement('div', { className: className, style: style });
    }
  }, {
    key: 'renderFirst',
    value: function renderFirst() {
      return this.renderAt(0);
    }
  }, {
    key: 'renderSecond',
    value: function renderSecond() {
      return this.renderAt(1);
    }
  }, {
    key: 'renderAt',
    value: function renderAt(index) {
      var children = this.p.children;

      return children[index];
    }
  }, {
    key: 'constrain',
    value: function constrain(value, _ref) {
      var min = _ref.min;
      var max = _ref.max;
      var constrain = this.props.constrain;


      if (constrain === false) {
        return {
          value: value,
          consrained: false
        };
      }

      if (typeof constrain == 'function') {
        return this.props.constrain(value, { min: min, max: max });
      }

      var result = clamp(value, min, max);

      return {
        value: result,
        constrained: result !== value
      };
    }
  }, {
    key: 'handleSplitterDragStart',
    value: function handleSplitterDragStart(diff, event) {

      var props = this.p;
      var fn = props[props.onDragStartName];

      if (typeof fn == 'function') {
        fn(diff, event);
      }

      var nodes = this.getNodes();
      var sizes = nodes.map(getOffsetSize);

      this.sizes = sizes;
      this.splitterPosition = sizes[0][props.sizeName];
      this.splitterSize = sizes[2][props.sizeName];

      var minSize = props.minSize || [];
      var maxSize = props.maxSize || [];

      var available = sizes[0][props.sizeName] + sizes[1][props.sizeName];

      var splitterMin = 0;
      var splitterMax = available;

      if (minSize[0]) {
        splitterMin += minSize[0];
      }
      if (minSize[1]) {
        splitterMax -= minSize[1];
      }

      if (maxSize[0]) {
        splitterMax = Math.min(splitterMax, maxSize[0]);
      }

      if (maxSize[1]) {
        splitterMin = Math.max(splitterMin, available - maxSize[1]);
      }

      var values = minMax(splitterMin, splitterMax);

      this.splitterMin = values.min;
      this.splitterMax = values.max;
    }
  }, {
    key: 'handleSplitterDrag',
    value: function handleSplitterDrag(diff, event) {

      var props = this.p;

      var positions = getPositionNames(this.props);
      var posName = positions[0];
      var offset = diff[posName];

      if (!offset) {
        return;
      }

      var fn = this.props[this.props.onDragName];

      if (typeof fn == 'function') {
        fn(diff, event);
      }

      var dragPosition = this.splitterPosition + offset;

      var _constrain = this.constrain(dragPosition, {
        min: this.splitterMin,
        max: this.splitterMax
      });

      var value = _constrain.value;
      var constrained = _constrain.constrained;


      if (!props.resizeProxy) {

        this.doResize(value, { constrain: false });

        if (this.state.constrained != constrained) {
          this.setState({ constrained: constrained });
        }
      } else {

        this.setState({
          dragging: true,
          dragPosition: value,
          constrained: constrained
        });
      }
    }
  }, {
    key: 'handleSplitterDrop',
    value: function handleSplitterDrop(diff, event) {

      var props = this.p;
      var positions = getPositionNames(props);
      var posName = positions[0];

      var offset = diff[posName];
      var position = this.splitterPosition + offset;

      if (!offset) {

        delete this.sizes;
        delete this.splitterPosition;
        delete this.splitterSize;

        return;
      }

      var state = {
        dragging: false,
        dragPosition: null,
        constrained: false
      };

      this.setState(state);

      this.doResize(position);

      delete this.sizes;
      delete this.splitterPosition;
      delete this.splitterSize;
    }
  }, {
    key: 'doResize',
    value: function doResize(at) {
      var _ref2 = arguments.length <= 1 || arguments[1] === undefined ? { constrain: true } : arguments[1];

      var _ref2$constrain = _ref2.constrain;
      var constrain = _ref2$constrain === undefined ? true : _ref2$constrain;

      var props = this.p;

      var constrained = false;
      var value = at;

      if (constrain) {
        var result = this.constrain(at, {
          min: this.splitterMin,
          max: this.splitterMax
        });

        value = result.value;
        constrained = result.constrained;
      }

      var splitAtIndex = props.splitAtIndex;
      var sizeName = props.sizeName;


      var sizes = this.sizes;
      var sign = splitAtIndex == 1 ? -1 : 1;

      if (splitAtIndex == 1) {
        value = sizes[0][sizeName] + sizes[1][sizeName] - value;
      }

      value *= sign;

      if (this.props.splitAt == null) {
        this.setState({
          splitAt: value
        });
      }

      this.props.onResize(value);
    }
  }, {
    key: 'handleCollapse',
    value: function handleCollapse(collapsedIndex) {
      if (this.props.collapsedIndex === undefined) {
        this.setState({
          collapsedIndex: collapsedIndex
        });

        this.doTransition(this.p, this.p.collapsedIndex, collapsedIndex);
      }

      this.props.onCollapse(collapsedIndex);
    }
  }, {
    key: 'handleExpand',
    value: function handleExpand(expandIndex) {

      var collapsedIndex = this.p.collapsedIndex;

      if (expandIndex !== collapsedIndex) {
        //invalid expand
        return;
      }

      if (this.props.collapsedIndex === undefined) {
        this.setState({
          collapsedIndex: null
        });

        this.doTransition(this.p, collapsedIndex, null);
      }

      this.props.onExpand(expandIndex);
    }
  }]);

  return SplitContainer;
}(_reactClass2.default);

exports.default = SplitContainer;


SplitContainer.propTypes = {
  children: function children(props, propName) {
    var propValue = _react2.default.Children.toArray(props[propName]);

    propValue = propValue.filter(function (child) {
      if (child && child.props && child.props.isSplitter) {
        return null;
      }
      return child;
    });

    var isArray = Array.isArray(propValue);
    var isTwo = isArray && propValue.length == 2;

    if (!propValue || !isArray || !isTwo) {
      console.warn('Please pass only 2 children. You provided ' + (isArray ? propValue.length + ' children' : propValue));
    }
  },

  orientation: _react.PropTypes.oneOf(['horizontal', 'vertical']),

  locked: _react.PropTypes.bool,
  draggable: _react.PropTypes.bool,

  splitAt: function splitAt(props, propName) {
    var value = props[propName];
    var fixedIndex = props.fixedIndex;

    if (isPercentage(value) && (fixedIndex == 0 || fixedIndex == 1)) {
      return new Error('"fixedIndex" should be used when "spliAt" is a expressed as a fixed number, and not as a percentage');
    }
  }
};

SplitContainer.defaultProps = {
  theme: 'default',

  fixedIndex: -1,
  orientation: 'horizontal',

  cover: true,
  draggable: true,
  locked: false,

  resizeProxy: true,

  onCollapse: function onCollapse() {},
  onExpand: function onExpand() {},
  onResize: function onResize() {},

  collapsible: [true, true]
};