'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _reactStyleNormalizer = require('react-style-normalizer');

var _reactStyleNormalizer2 = _interopRequireDefault(_reactStyleNormalizer);

var _Splitter = require('./Splitter');

var _Splitter2 = _interopRequireDefault(_Splitter);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _join = require('./join');

var _join2 = _interopRequireDefault(_join);

var _bemFactory = require('./bemFactory');

var _bemFactory2 = _interopRequireDefault(_bemFactory);

var _isNumber = require('./isNumber');

var _isNumber2 = _interopRequireDefault(_isNumber);

var _calc = require('./calc');

var _calc2 = _interopRequireDefault(_calc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PERCENTAGE_RE = /%/;

var CLASS_NAME = 'react-split-container';
var bem = (0, _bemFactory2.default)(CLASS_NAME);
var m = function m(name) {
    return bem(null, name);
};

var isPercentage = function isPercentage(n) {
    if ((0, _isNumber2.default)(n)) {
        return false;
    }

    return typeof n == 'string' && (0, _isNumber2.default)(n.replace(PERCENTAGE_RE, ''));
};

var getSizeName = function getSizeName(props) {
    var H = props.orientation == 'horizontal';
    return H ? 'height' : 'width';
};

var getPositionNames = function getPositionNames(props) {
    var H = props.orientation == 'horizontal';
    return H ? ['top', 'bottom'] : ['left', 'right'];
};

var getClientSizeName = function getClientSizeName(props) {
    var sizeName = getSizeName(props);
    return 'client' + sizeName[0].toUpperCase() + sizeName.substring(1);
};

var getFixedIndex = function getFixedIndex(props) {
    if (typeof props.fixedIndex == 'string') {
        props.fixedIndex *= 1;
    }

    return props.fixedIndex === 0 ? 0 : props.fixedIndex === 1 ? 1 : -1;
};
var emptyFn = function emptyFn() {};

var SplitContainer = function (_Component) {
    _inherits(SplitContainer, _Component);

    function SplitContainer(props) {
        _classCallCheck(this, SplitContainer);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(SplitContainer).call(this, props));

        _this.state = {
            dragging: false
        };
        return _this;
    }

    _createClass(SplitContainer, [{
        key: 'isMounted',
        value: function isMounted() {
            return !!(0, _reactDom.findDOMNode)(this);
        }
    }, {
        key: 'prepareStyle',
        value: function prepareStyle(props, state) {

            var H = props.orientation == 'horizontal';

            var defaultOrientationStyle = H ? props.defaultHorizontalStyle : props.defaultVerticalStyle;

            var style = (0, _objectAssign2.default)({}, props.defaultStyle, props.style);

            if (state.dragging) {
                (0, _objectAssign2.default)(style, {
                    cursor: H ? 'ns-resize' : 'ew-resize'
                });
            }

            return (0, _objectAssign2.default)(style, defaultOrientationStyle);
        }
    }, {
        key: 'adjustMinSizes',
        value: function adjustMinSizes(splitterSize, props, state, styles) {
            var H = props.orientation == 'horizontal';
            var minSizeName = H ? 'minHeight' : 'minWidth';
            var maxSizeName = H ? 'maxHeight' : 'maxWidth';

            var totalMinSize = 0;

            var collapsedInfo = this.getCollapsedInfo(props, state);

            if (props.firstMinSize) {
                totalMinSize += props.firstMinSize;
                styles.first[minSizeName] = props.firstMinSize;
                styles.second[maxSizeName] = (0, _calc2.default)('100%', -props.firstMinSize, -splitterSize);
            }

            if (props.secondMinSize) {
                totalMinSize += props.secondMinSize;
                styles.second[minSizeName] = props.secondMinSize;
                styles.first[maxSizeName] = (0, _calc2.default)('100%', -props.secondMinSize, -splitterSize);
            }

            if (collapsedInfo.first) {
                delete styles.second[maxSizeName];
            }

            if (collapsedInfo.second) {
                delete styles.first[maxSizeName];
            }

            if (totalMinSize) {
                props.style[minSizeName] = totalMinSize;
            }
        }
    }, {
        key: 'prepareSplitterStyle',
        value: function prepareSplitterStyle(props, state) {
            var H = props.orientation == 'horizontal';
            var sizeName = getSizeName(props);

            var defaultOrientationSplitterStyle = H ? props.defaultHorizontalSplitterStyle : props.defaultVerticalSplitterStyle;
            var splitterStyle = (0, _objectAssign2.default)({}, props.defaultSplitterStyle, defaultOrientationSplitterStyle, props.splitterStyle);

            if (props.splitterSize) {
                splitterStyle[sizeName] = props.splitterSize;
            }

            if (typeof splitterStyle[sizeName] === 'undefined') {
                splitterStyle[sizeName] = props.defaultSplitterSize;
            }

            if (state.dragging) {
                // assign(splitterStyle, state.dragSplitterStyle)
            }

            var collapsedInfo = this.getCollapsedInfo(props, state);

            if (collapsedInfo.first || collapsedInfo.second || props.locked) {
                splitterStyle.cursor = 'auto';
            }

            return (0, _reactStyleNormalizer2.default)(splitterStyle);
        }
    }, {
        key: 'getCollapsedInfo',
        value: function getCollapsedInfo(props, state) {

            var first = typeof state.firstCollapsed != 'undefined' ? state.firstCollapsed : props.firstCollapsed;

            var second = typeof state.secondCollapsed != 'undefined' ? state.secondCollapsed : props.secondCollapsed;

            return {
                first: first,
                second: second
            };
        }
    }, {
        key: 'prepareChildrenStyles',
        value: function prepareChildrenStyles(props, state, splitterSize) {
            var sizeName = getSizeName(props);
            var styles = _styles2.default.prepare(props);
            var halfSplitter = splitterSize / 2;

            var offset = state.dragOffset || 0;
            var splitAt = props.splitAt;
            var FIRST;
            var SECOND;

            var collapsedInfo = this.getCollapsedInfo(props, state);

            if (collapsedInfo.first || collapsedInfo.second) {
                if (collapsedInfo.first) {
                    SECOND = (0, _calc2.default)('100%', -splitterSize);
                    styles.first.display = 'none';
                } else {
                    FIRST = (0, _calc2.default)('100%', -splitterSize);
                    styles.second.display = 'none';
                }
            } else {
                if ((0, _isNumber2.default)(splitAt)) {
                    FIRST = (0, _calc2.default)(splitAt, offset);
                    SECOND = (0, _calc2.default)('100%', -splitAt, -splitterSize, -offset);
                } else {
                    FIRST = (0, _calc2.default)(splitAt, -halfSplitter, offset);
                    SECOND = (0, _calc2.default)('100%', '-', splitAt, -halfSplitter, -offset);
                }
            }

            styles.first[sizeName] = FIRST;
            styles.second[sizeName] = SECOND;

            return styles;
        }
    }, {
        key: 'prepareProps',
        value: function prepareProps(thisProps) {
            var props = this.p = (0, _objectAssign2.default)({}, thisProps);

            var H = props.horizontal = props.orientation == 'horizontal';

            props.className = this.prepareClassName(props);

            return props;
        }
    }, {
        key: 'prepareClassName',
        value: function prepareClassName(props) {
            return (0, _join2.default)(CLASS_NAME, m(props.orientation), props.theme && m('theme-' + props.theme));
        }
    }, {
        key: 'render',
        value: function render() {
            var props = this.p = this.prepareProps(this.props);

            var H = props.horizontal;
            var sizeName = H ? 'height' : 'width';

            this.asPercentage = isPercentage(props.splitAt);

            props.children = props.children || [];

            var splitAtInState = typeof this.state.splitAt != 'undefined';

            if (splitAtInState) {
                props.splitAt = this.state.splitAt;
            }

            props.splitterStyle = this.prepareSplitterStyle(props, this.state);
            props.style = this.prepareStyle(props, this.state);

            var splitterSize = props.splitterSize = parseFloat(props.splitterStyle[sizeName]);

            if (this._adjusting) {
                this.adjustBefore(props, this.state, splitterSize);
            }

            var childrenStyles = this.prepareChildrenStyles(props, this.state, splitterSize);

            if (this._adjusting) {
                this.adjustAfter(props, this.state, childrenStyles);
            }

            this.adjustMinSizes(splitterSize, props, this.state, childrenStyles);

            if (this.shouldAdjust(props)) {

                if (!this._adjusting) {
                    setTimeout(function () {

                        this._adjusting = true;

                        if (!this.isMounted()) {
                            return;
                        }

                        this.setState({}, function () {
                            this._adjusting = false;
                        }.bind(this));
                    }.bind(this), 0);
                } else {
                    this._adjusting = false;
                }
            }

            var collapsedInfo = this.getCollapsedInfo(props, this.state);

            this.state.props = props;

            return _react2.default.createElement(
                'div',
                props,
                _react2.default.createElement(
                    'div',
                    { className: (0, _join2.default)("item first", CLASS_NAME + '__first', CLASS_NAME + '__first--orientation-' + props.orientation), style: childrenStyles.first },
                    props.children[0]
                ),
                _react2.default.createElement(_Splitter2.default, {
                    beforeMin: props.firstMinSize,
                    afterMin: props.secondMinSize,
                    size: splitterSize,
                    arrowSize: props.arrowSize,
                    arrowColor: props.arrowColor,
                    arrowPadding: props.arrowPadding,
                    style: props.splitterStyle,
                    onDragStart: this.handleSplitterDragStart,
                    onDrag: this.handleSplitterDrag,
                    onDrop: this.handleSplitterDrop,
                    onCollapse: this.handleCollapse,
                    onExpand: this.handleExpand,
                    orientation: props.orientation,
                    locked: props.locked,
                    firstCollapsed: collapsedInfo.first,
                    secondCollapsed: collapsedInfo.second,
                    firstCollapsible: props.firstCollapsible,
                    secondCollapsible: props.secondCollapsible,
                    onMouseDown: this.handleSplitterMouseDown
                }),
                _react2.default.createElement(
                    'div',
                    { className: (0, _join2.default)("item first", CLASS_NAME + '__second', CLASS_NAME + '__second--orientation-' + props.orientation), style: childrenStyles.second },
                    props.children[1]
                )
            );
        }
    }, {
        key: 'getSplitterSize',
        value: function getSplitterSize(props) {
            props = props || this.props;

            var splitterStyle = props.splitterStyle;

            return splitterStyle[getSizeName(props)] || 10;
        }
    }, {
        key: 'getTotalSize',
        value: function getTotalSize(props) {
            props = props || this.props;

            var domNode = (0, _reactDom.findDOMNode)(this);

            return domNode[getClientSizeName(props)];
        }
    }, {
        key: 'adjustBefore',
        value: function adjustBefore(props, state, splitterSize) {
            var fixedIndex = getFixedIndex(props);
            var currentSize;
            var currentSplit;

            if (! ~fixedIndex) {
                if (!isPercentage(props.splitAt)) {
                    props.splitAt = this.getPercentageFor(parseFloat(props.splitAt) + splitterSize / 2) + '%';
                }
                return;
            }

            if (fixedIndex === 0) {
                if (!(0, _isNumber2.default)(props.splitAt)) {
                    currentSize = this.getTotalSize(props);
                    currentSplit = parseFloat(props.splitAt);
                    //split as is not a number, but a percentage, but we have to make it a number
                    props.splitAt = currentSplit * currentSize / 100 - splitterSize / 2;
                }
            }
        }
    }, {
        key: 'getPercentageFor',
        value: function getPercentageFor(size, props) {

            var totalSize = this.getTotalSize(props);

            return size * 100 / totalSize;
        }
    }, {
        key: 'adjustAfter',
        value: function adjustAfter(props, state, childrenStyles) {
            var collapsedInfo = this.getCollapsedInfo(props, state);

            if (collapsedInfo.first || collapsedInfo.second) {
                return;
            }

            if (getFixedIndex(props) === 1) {
                var sizeName = getSizeName(props);
                var clientSizeName = getClientSizeName(props);
                var domNode = (0, _reactDom.findDOMNode)(this).children[2];
                var size = domNode[clientSizeName];

                childrenStyles.second[sizeName] = size;
                childrenStyles.first[sizeName] = (0, _calc2.default)('100%', -props.splitterStyle[sizeName], -size);
            }
        }
    }, {
        key: 'shouldAdjust',
        value: function shouldAdjust(props) {
            if (this.state.dragging) {
                return false;
            }

            var fixedIndex = getFixedIndex(props);

            if (! ~fixedIndex) {
                //when there is no fixed index, both have to be flexible,
                //so splitAt must be a percentage value.
                //if it's not, we should adjust
                return !isPercentage(props.splitAt);
            }
            if (fixedIndex === 0) {
                //when the first should be fixed,
                //we only have to adjust if splitAt is not a number, but a percentage
                return !(0, _isNumber2.default)(props.splitAt);
            }

            //fixed index is 1
            //so we always have to adjust
            return true;
        }
    }, {
        key: 'handleSplitterMouseDown',
        value: function handleSplitterMouseDown(event) {
            this.props.onSplitterMouseDown(event);
        }
    }, {
        key: 'handleSplitterDragStart',
        value: function handleSplitterDragStart(diff, event) {
            this.props[this.props.onDragStartName](diff, event);
        }
    }, {
        key: 'getCurrentSplitAt',
        value: function getCurrentSplitAt() {
            var clientSizeName = getClientSizeName(this.state.props);
            var firstChild = (0, _reactDom.findDOMNode)(this).children[0];
            var splitAt = firstChild[clientSizeName];

            return splitAt;
        }
    }, {
        key: 'handleSplitterDrag',
        value: function handleSplitterDrag(diff, event) {
            var positions = getPositionNames(this.props);
            var posName = positions[0];
            var pos = diff[posName];

            this.props[this.props.onDragName](diff, event);

            pos = diff[posName];

            var dragSplitterStyle = {};

            dragSplitterStyle[positions[0]] = pos;

            this.setState({
                dragging: true,
                dragOffset: pos,
                dragSplitterStyle: dragSplitterStyle
            });

            return pos;
        }
    }, {
        key: 'handleSplitterDrop',
        value: function handleSplitterDrop(diff, event) {

            var positions = getPositionNames(this.props);
            var posName = positions[0];
            var pos = diff[posName];

            var state = {
                dragging: false,
                dragOffset: 0,
                dragSplitterStyle: null
            };

            if (pos) {
                var props = this.state.props;
                var currentSplitAt = this.getCurrentSplitAt();

                var propsForAdjust = {
                    splitAt: currentSplitAt,
                    orientation: this.props.orientation,
                    fixedIndex: this.props.fixedIndex
                };

                this.adjustBefore(propsForAdjust, this.state, props.splitterSize);

                var splitAt = propsForAdjust.splitAt;

                if (this.props.stateful) {
                    state.splitAt = splitAt;
                }
            }

            this.setState(state);

            if (!pos) {
                return;
            }

            //for the onDrop handler, we need to make sure we return the splitAt
            //in the exact same format as it was passed in the original props (either number or percentage)
            if (this.asPercentage != isPercentage(splitAt)) {

                if (this.asPercentage && !isPercentage(splitAt)) {
                    splitAt = this.getPercentageFor(splitAt + props.splitterSize / 2);
                }

                if (!this.asPercentage && isPercentage(splitAt)) {
                    splitAt = currentSplitAt;
                }

                if (this.asPercentage && !isPercentage(splitAt)) {
                    splitAt += '%';
                }
            }

            this.props[this.props.onDropName](splitAt, event);
        }
    }, {
        key: 'handleCollapse',
        value: function handleCollapse(direction) {
            var state = {};

            if (direction == -1) {
                state.firstCollapsed = true;
            } else {
                state.secondCollapsed = true;
            }

            if (this.props.stateful) {
                this.setState(state);
            }

            this.props[this.props.onCollapseName](state.firstCollapsed ? 0 : 1);
        }
    }, {
        key: 'handleExpand',
        value: function handleExpand(direction) {
            var state = {};

            if (direction == -1) {
                state.firstCollapsed = false;
            } else {
                state.secondCollapsed = false;
            }

            if (this.props.stateful) {
                this.setState(state);
            }

            this.props[this.props.onExpandName](state.firstCollapsed === false ? 0 : 1);
        }
    }]);

    return SplitContainer;
}(_reactClass2.default);

exports.default = SplitContainer;


SplitContainer.propTypes = {
    children: function children(props, propName) {
        var propValue = _react2.default.Children.toArray(props[propName]);

        var isArray = Array.isArray(propValue);
        var isTwo = isArray && propValue.length == 2;

        if (!propValue || !isArray || !isTwo) {
            console.warn('Please pass only 2 children. You provided ' + (isArray ? propValue.length + ' children' : propValue));
        }
    },

    orientation: _react.PropTypes.oneOf(['horizontal', 'vertical']),

    splitterSize: _react.PropTypes.number,
    locked: _react.PropTypes.bool,
    stateful: _react.PropTypes.bool
};

SplitContainer.defaultProps = (0, _objectAssign2.default)({
    theme: 'default',
    orientation: 'horizontal',
    defaultStyle: {},
    defaultHorizontalStyle: {},
    defaultVerticalStyle: {},
    defaultSplitterStyle: {},
    defaultHorizontalSplitterStyle: {},
    defaultVerticalSplitterStyle: {},

    // defaultSplitterSize: 12,
    arrowSize: 6,
    arrowColor: 'rgb(118, 118, 118)',
    arrowPadding: 10,
    splitAt: '50%',

    fixedIndex: null,
    locked: false,
    stateful: false,
    onDrop: emptyFn,
    onDragStart: emptyFn,
    onDrag: emptyFn,
    onSplitterMouseDown: emptyFn,
    onExpand: emptyFn,
    onCollapse: emptyFn,

    onDragStartName: 'onDragStart',
    onDragName: 'onDrag',
    onDropName: 'onDrop',
    onExpandName: 'onExpand',
    onCollapseName: 'onCollapse'

}, _styles2.default.defaults);