'use strict';

var assign = require('object-assign')

module.exports = function(splitterSize, config){
    config = config || {}

    var arrowSize  = config.arrowSize || 6
    var arrowColor = config.arrowColor || 'red'
    var PADDING    = config.arrowPadding || 3

    var ARROW_STYLE = {
        display: 'inline-block'
    }

    var FIRST_ARROW_STYLE = assign({}, ARROW_STYLE)

    var SECOND_ARROW_STYLE = assign({}, ARROW_STYLE)

    var ORIENTATION = {
        horizontal: {
            first: {
                borderLeft  : arrowSize + 'px solid transparent',
                borderRight : arrowSize + 'px solid transparent',
                borderBottom: arrowSize + 'px solid ' + arrowColor
            },
            second: {
                borderLeft : arrowSize + 'px solid transparent',
                borderRight: arrowSize + 'px solid transparent',
                borderTop  : arrowSize + 'px solid ' + arrowColor
            }
        },
        vertical: {
            first: {
                borderTop   : arrowSize + 'px solid transparent',
                borderBottom: arrowSize + 'px solid transparent',
                borderRight : arrowSize + 'px solid ' + arrowColor,
            },
            second: {
                borderTop   : arrowSize + 'px solid transparent',
                borderBottom: arrowSize + 'px solid transparent',
                borderLeft  : arrowSize + 'px solid ' + arrowColor
            }
        }
    }

    var HORIZONTAL_WRAPPER_STYLE = {
        cursor      : 'pointer',
        height      : '100%',
        paddingLeft : PADDING,
        paddingRight: PADDING,
        position : 'relative',
        display : 'flex',
        alignItems: 'center',
        flexFlow: 'row'
    }

    var VERTICAL_WRAPPER_STYLE = {
        cursor       : 'pointer',
        width        : '100%',
        paddingTop   : PADDING,
        paddingBottom: PADDING,
        position     : 'relative',
        display      : 'flex',
        alignItems   : 'center',
        flexFlow     : 'column'
    }

    var WRAPPER_STYLE = {
        horizontal: {
            first : assign({}, HORIZONTAL_WRAPPER_STYLE),
            second: assign({}, HORIZONTAL_WRAPPER_STYLE)
        },
        vertical: {
            first : assign({}, VERTICAL_WRAPPER_STYLE),
            second: assign({}, VERTICAL_WRAPPER_STYLE)
        }
    }

    var INNER_STYLE = {
        horizontal: {
            position : 'absolute',
            transform: 'translate3d(-50%, 0px, 0px)',
            left     : '50%',
            height   : '100%',
            display  : 'inline-flex',
            flexFlow : 'row'
        },
        vertical: {
            position : 'absolute',
            transform: 'translate3d(0px, -50%, 0px)',
            width    : '100%',
            top      : '50%'
        }
    }

    return {
        innerStyle      : INNER_STYLE,
        wrapperStyle    : WRAPPER_STYLE,
        arrowStyle      : ORIENTATION,
        firstArrowStyle : FIRST_ARROW_STYLE,
        secondArrowStyle: SECOND_ARROW_STYLE
    }
}